## securefs 0.8.2+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

option(PORTABLE_BUILD "Build for the general architecture instead of this cpu" OFF)

project(securefs)

set (CMAKE_FIND_FRAMEWORK NEVER)

if (UNIX)
    find_path(FUSE_INCLUDE_DIR fuse.h PATHS /usr/local/include PATH_SUFFIXES osxfuse)
    if (APPLE)
        find_library(FUSE_LIBRARIES osxfuse PATHS /usr/local/lib)
    else()
        find_library(FUSE_LIBRARIES fuse PATHS /usr/local/lib)
    endif()
    include_directories(${FUSE_INCLUDE_DIR})
    link_libraries(${FUSE_LIBRARIES})
    add_compile_options(-Wall -Wextra -Wno-unknown-pragmas -std=gnu++11)

    if (NOT PORTABLE_BUILD)
        add_compile_options(-march=native -mtune=native)
    endif ()

    if (APPLE)
        link_libraries(-Wl,-dead_strip)
    else ()
        add_compile_options(-pthread)
        link_libraries(-pthread)
    endif ()
    link_libraries(${CMAKE_DL_LIBS})
else ()
    add_definitions(-DNOMINMAX=1)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS=1)
    add_definitions(-D__STDC__=1)
    if (NOT WINFSP_PREFIX)
        message("WINFSP_PREFIX not set, fallback to default value")
        set(WINFSP_PREFIX "C:/Program Files (x86)/WinFsp")
    endif ()
    if (${CMAKE_SIZEOF_VOID_P} EQUAL 8)
        set(ARCH x64)
    else ()
        set(ARCH x86)
    endif ()
    set(FUSE_INCLUDE_DIR ${WINFSP_PREFIX}/inc/fuse)
    include_directories(${WINFSP_PREFIX}/inc)
    include_directories(${FUSE_INCLUDE_DIR})
    link_libraries(${WINFSP_PREFIX}/lib/winfsp-${ARCH}.lib)
    link_libraries(-DELAYLOAD:winfsp-${ARCH}.dll)
    link_libraries(delayimp.lib)
    add_compile_options(/MP)
endif ()

add_definitions(-D_REENTRANT -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=28)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif ()

include_directories(sources)
set(EXTERNAL_DIR external)
include_directories(${EXTERNAL_DIR})

set(CRYPTOPP_DIR ${EXTERNAL_DIR}/cryptopp)
add_subdirectory(${CRYPTOPP_DIR})
link_libraries(cryptopp-static)

file(GLOB SOURCES sources/*.cpp sources/*.h ${EXTERNAL_DIR}/*.h ${EXTERNAL_DIR}/*.hpp ${EXTERNAL_DIR}/*.cpp)
file(GLOB TEST_SOURCES test/*.cpp)
add_library(securefs-static STATIC ${SOURCES})
link_libraries(securefs-static)

add_executable(securefs main.cpp)
add_executable(securefs_test ${TEST_SOURCES})

if (UNIX)
    set (CMAKE_REQUIRED_FLAGS "-std=gnu++11")
endif()

include(CheckCXXSourceRuns)
CHECK_CXX_SOURCE_RUNS("int main() { thread_local int i = 0; return i; }" HAS_THREAD_LOCAL)

CHECK_CXX_SOURCE_RUNS("
#include <time.h>

int main() {
    timespec ts;
    clock_gettime(CLOCK_REALTIME, &ts);
    return 0;
}
" HAS_CLOCK_GETTIME)

CHECK_CXX_SOURCE_RUNS("
#include <unistd.h>
#include <sys/stat.h>

int main() {
    futimens(-1, nullptr);
    return 0;
}
" HAS_FUTIMENS)

CHECK_CXX_SOURCE_RUNS("
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

int main() {
    utimensat(-1, nullptr, nullptr, 0);
    return 0;
}
" HAS_UTIMENSAT)

configure_file(sources/securefs_config.in securefs_config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

enable_testing()
add_test(NAME sec_test COMMAND securefs_test)
add_test(NAME simple_test COMMAND /usr/bin/env build_config_type=${CMAKE_BUILD_TYPE} /usr/bin/python ${PROJECT_SOURCE_DIR}/test/simple_test.py)

install(TARGETS securefs DESTINATION bin)

=== debian/changelog ===
securefs (0.8.2+ds-2) unstable; urgency=medium

  * d/patches: Add a patch to fix build issue on ppc64el architecture.

 -- Yanhao Mo <yanhaocs@gmail.com>  Mon, 24 Dec 2018 11:56:12 +0800

securefs (0.8.2+ds-1) unstable; urgency=low

  * Initial release. Closes: #906791

 -- Yanhao Mo <yanhaocs@gmail.com>  Mon, 27 Aug 2018 10:17:49 +0800

=== debian/control ===
Source: securefs
Section: utils
Priority: optional
Maintainer: Yanhao Mo <yanhaocs@gmail.com>
Uploaders: SZ Lin (林上智) <szlin@debian.org>
Build-Depends:
 cmake,
 debhelper (>=11~),
 libfuse-dev,
 libcrypto++-dev,
 libjsoncpp-dev,
 libtclap-dev,
 libutfcpp-dev,
 catch,
Standards-Version: 4.2.1
Homepage: https://github.com/netheril96/securefs
Vcs-Git: https://salsa.debian.org/debian/securefs.git
Vcs-Browser: https://salsa.debian.org/debian/securefs

Package: securefs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 fuse,
Description: Filesystem in userspace with transparent authenticated encryption
 securefs mounts a regular directory onto a mount point. The
 mount point appears as a regular filesystem, where one can
 read/write/create files, directories and symbolic links.
 The underlying directory will be automatically updated to
 contain the encrypted and authenticated contents.

=== debian/watch ===
version=4
opts="dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,repackasuffix=+ds, \
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%securefs-$1.tar.gz%" \
 https://github.com/netheril96/securefs/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## securefs 0.8.3%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,11 @@
 project(securefs)
 
 set (CMAKE_FIND_FRAMEWORK NEVER)
+
+execute_process (
+    COMMAND bash -c "uname -m"
+    OUTPUT_VARIABLE architecture
+)
 
 if (UNIX)
     find_path(FUSE_INCLUDE_DIR fuse.h PATHS /usr/local/include PATH_SUFFIXES osxfuse)
@@ -18,7 +23,11 @@
     add_compile_options(-Wall -Wextra -Wno-unknown-pragmas -std=gnu++11)
 
     if (NOT PORTABLE_BUILD)
-        add_compile_options(-march=native -mtune=native)
+        if (NOT "${architecture}" STREQUAL "ppc64le\n")
+            add_compile_options(-march=native -mtune=native)
+        else ()
+            add_compile_options(-mcpu=native -mtune=native)
+        endif()
     endif ()
 
     if (APPLE)

## securefs 0.8.3+ds

=== debian/changelog ===
securefs (0.8.3+ds-1) unstable; urgency=medium

  * New upstream version 0.8.3+ds
  * d/watch: Fix a typo (Closes: #918220) .
  * Standards-Version: Bump to 4.3.0 (no changes needed).

 -- Yanhao Mo <yanhaocs@gmail.com>  Mon, 25 Feb 2019 14:26:07 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Section: utils
 Priority: optional
 Maintainer: Yanhao Mo <yanhaocs@gmail.com>
-Uploaders: SZ Lin (林上智) <szlin@debian.org>
 Build-Depends:
  cmake,
  debhelper (>=11~),
@@ -12,7 +11,7 @@
  libtclap-dev,
  libutfcpp-dev,
  catch,
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://github.com/netheril96/securefs
 Vcs-Git: https://salsa.debian.org/debian/securefs.git
 Vcs-Browser: https://salsa.debian.org/debian/securefs

=== debian/tests/control ===
Test-Command: cd obj-x86_64-linux-gnu && python2.7 ../test/simple_test.py
Depends: python2, fuse, libcrypto++6, libfuse2, libjsoncpp1
Restrictions: build-needed, isolation-machine, allow-stderr

Test-Command: cd obj-x86_64-linux-gnu && ./securefs_test
Depends: fuse, libcrypto++6, libfuse2, libjsoncpp1
Restrictions: build-needed

## securefs 0.9.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,9 @@
-cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
-
-option(PORTABLE_BUILD "Build for the general architecture instead of this cpu" OFF)
+cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
 
 project(securefs)
+if (POLICY CMP0048)
+  cmake_policy(SET CMP0048 NEW)
+endif()
 
 set (CMAKE_FIND_FRAMEWORK NEVER)
 
@@ -10,6 +11,11 @@
     COMMAND bash -c "uname -m"
     OUTPUT_VARIABLE architecture
 )
+
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake-modules/")
+include(GetGitRevisionDescription)
+git_describe(GIT_VERSION --tags)
+configure_file(${CMAKE_SOURCE_DIR}/sources/git-version.cpp.in ${CMAKE_BINARY_DIR}/git-version.cpp)
 
 if (UNIX)
     find_path(FUSE_INCLUDE_DIR fuse.h PATHS /usr/local/include PATH_SUFFIXES osxfuse)
@@ -20,15 +26,8 @@
     endif()
     include_directories(${FUSE_INCLUDE_DIR})
     link_libraries(${FUSE_LIBRARIES})
-    add_compile_options(-Wall -Wextra -Wno-unknown-pragmas -std=gnu++11)
-
-    if (NOT PORTABLE_BUILD)
-        if (NOT "${architecture}" STREQUAL "ppc64le\n")
-            add_compile_options(-march=native -mtune=native)
-        else ()
-            add_compile_options(-mcpu=native -mtune=native)
-        endif()
-    endif ()
+    add_compile_options(-Wall -Wextra -Wno-unknown-pragmas)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=gnu++11")
 
     if (APPLE)
         link_libraries(-Wl,-dead_strip)
@@ -59,7 +58,7 @@
     add_compile_options(/MP)
 endif ()
 
-add_definitions(-D_REENTRANT -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=28)
+add_definitions(-D_REENTRANT -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=28 -DUTF8PROC_EXPORTS=1)
 
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Release)
@@ -73,17 +72,13 @@
 add_subdirectory(${CRYPTOPP_DIR})
 link_libraries(cryptopp-static)
 
-file(GLOB SOURCES sources/*.cpp sources/*.h ${EXTERNAL_DIR}/*.h ${EXTERNAL_DIR}/*.hpp ${EXTERNAL_DIR}/*.cpp)
+file(GLOB SOURCES sources/*.cpp sources/*.h ${EXTERNAL_DIR}/*.h ${EXTERNAL_DIR}/*.hpp ${EXTERNAL_DIR}/*.cpp ${CMAKE_BINARY_DIR}/git-version.cpp ${EXTERNAL_DIR}/utf8proc/utf8proc.h ${EXTERNAL_DIR}/utf8proc/utf8proc.c)
 file(GLOB TEST_SOURCES test/*.cpp)
 add_library(securefs-static STATIC ${SOURCES})
 link_libraries(securefs-static)
 
 add_executable(securefs main.cpp)
 add_executable(securefs_test ${TEST_SOURCES})
-
-if (UNIX)
-    set (CMAKE_REQUIRED_FLAGS "-std=gnu++11")
-endif()
 
 include(CheckCXXSourceRuns)
 CHECK_CXX_SOURCE_RUNS("int main() { thread_local int i = 0; return i; }" HAS_THREAD_LOCAL)

=== debian/changelog ===
securefs (0.9.0+ds-1.1) unstable; urgency=medium

  * Add test dependency libutf8proc2 (Closes: #951224).

 -- Yanhao Mo <yanhaocs@gmail.com>  Sat, 11 Apr 2020 01:10:15 +0800

securefs (0.9.0+ds-1) unstable; urgency=medium

  * New upstream version 0.9.0+ds
  * Update patches:
    - Rebasing aganist new upstream version
    - Build use native libutf8proc
  * Obsolete python2 (Closes: #943258)

 -- Yanhao Mo <yanhaocs@gmail.com>  Thu, 30 Jan 2020 13:12:04 +0800

## securefs 0.11.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,10 @@
     link_libraries(${FUSE_LIBRARIES})
     add_compile_options(-Wall -Wextra -Wno-unknown-pragmas)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=gnu++11")
+
+    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+        add_compile_options(-Wthread-safety -Wthread-safety-negative)
+    endif()
 
     if (APPLE)
         link_libraries(-Wl,-dead_strip)
@@ -119,6 +123,11 @@
 
 enable_testing()
 add_test(NAME sec_test COMMAND securefs_test)
-add_test(NAME simple_test COMMAND /usr/bin/env build_config_type=${CMAKE_BUILD_TYPE} /usr/bin/python ${PROJECT_SOURCE_DIR}/test/simple_test.py)
+find_package(Python3 COMPONENTS Interpreter)
+if (Python3_FOUND)
+    add_test(NAME simple_test COMMAND ${Python3_EXECUTABLE} ${PROJECT_SOURCE_DIR}/test/simple_test.py)
+else()
+add_test(NAME simple_test COMMAND python3 ${PROJECT_SOURCE_DIR}/test/simple_test.py)
+endif()
 
 install(TARGETS securefs DESTINATION bin)

=== debian/changelog ===
securefs (0.11.1+ds-4ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/p/0004-Ensure-tmp-dir-exists-before-use.patch:
      Ensure tmp dir exists before use.  Fixes FTBFS.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 30 Dec 2021 00:00:06 -0800

securefs (0.11.1+ds-4) unstable; urgency=medium

  * Bump Standards-Version to 4.6.0
  * d/control: Format by wrap-and-sort.
  * Get rid of lintian complain about uses-debhelper-compat-file.
  * Get rid of lintian complain about silent-on-rules-requiring-root.

 -- Yanhao <yanhaocs@gmail.com>  Sun, 03 Oct 2021 10:28:41 +0800

securefs (0.11.1+ds-3ubuntu3) jammy; urgency=medium

  * No-change rebuild against libjsoncpp25

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 14 Dec 2021 07:52:08 +0000

securefs (0.11.1+ds-3ubuntu2) hirsute; urgency=medium

  * Update-maintainer

 -- Bryce Harrington <bryce@canonical.com>  Fri, 09 Apr 2021 21:11:01 +0000

securefs (0.11.1+ds-3ubuntu1) hirsute; urgency=medium

  * d/p/0004-Ensure-tmp-dir-exists-before-use.patch:
    Ensure tmp dir exists before use.  Fixes FTBFS.

 -- Bryce Harrington <bryce@canonical.com>  Fri, 09 Apr 2021 02:43:27 +0000

securefs (0.11.1+ds-3) unstable; urgency=medium

  * Source only upload for migration to testing

 -- Yanhao Mo <yanhaocs@gmail.com>  Thu, 07 Jan 2021 14:20:48 +0800

securefs (0.11.1+ds-2) unstable; urgency=medium

  * update autotest dependencies (Closes: #978704)

 -- Yanhao Mo <yanhaocs@gmail.com>  Sun, 03 Jan 2021 17:24:29 +0800

securefs (0.11.1+ds-1) unstable; urgency=medium

  * New upstream version 0.11.1+ds

 -- Yanhao Mo <yanhaocs@gmail.com>  Sun, 30 Aug 2020 16:12:44 +0800

=== debian/control ===
Source: securefs
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Yanhao Mo <yanhaocs@gmail.com>
Build-Depends: catch,
               cmake,
               debhelper (>=11~),
               debhelper-compat (= 13),
               libcrypto++-dev,
               libfuse-dev,
               libjsoncpp-dev,
               libtclap-dev,
               libutf8proc-dev,
               libutfcpp-dev
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/netheril96/securefs
Vcs-Git: https://salsa.debian.org/debian/securefs.git
Vcs-Browser: https://salsa.debian.org/debian/securefs

Package: securefs
Architecture: any
Depends: fuse, ${misc:Depends}, ${shlibs:Depends}
Description: Filesystem in userspace with transparent authenticated encryption
 securefs mounts a regular directory onto a mount point. The
 mount point appears as a regular filesystem, where one can
 read/write/create files, directories and symbolic links.
 The underlying directory will be automatically updated to
 contain the encrypted and authenticated contents.

=== debian/tests/control ===
Test-Command: cd obj-x86_64-linux-gnu && python3 ../test/simple_test.py
Depends: fuse,
         libcrypto++-dev,
         libfuse-dev,
         libjsoncpp-dev,
         libutf8proc-dev,
         python3
Restrictions: build-needed, isolation-machine, allow-stderr

Test-Command: cd obj-x86_64-linux-gnu && ./securefs_test
Depends: fuse, libcrypto++-dev, libfuse-dev, libjsoncpp-dev, libutf8proc-dev
Restrictions: build-needed

## securefs 0.13.0+ds

=== debian/changelog ===
securefs (0.13.0+ds-2) unstable; urgency=medium

  * Fix autopkgtest by add allow-stderr tag (CLoses: #1021083).

 -- Yanhao <yanhaocs@gmail.com>  Sun, 16 Oct 2022 18:02:42 +0800

securefs (0.13.0+ds-1) unstable; urgency=medium

  * New upstream version 0.13.0+ds
  * Update copyright information
  * Update patches:
    - Build use native argon2 library

 -- Yanhao <yanhaocs@gmail.com>  Sat, 17 Sep 2022 15:45:53 +0800

## securefs 0.13.1%2Bds

=== external/cmake-cryptopp/CMakeLists.txt ===
# Please ensure your changes or patch meets minimum requirements.
#   The minimum requirements are 2.8.6. It roughly equates to
#   Ubuntu 14.05 LTS or Solaris 11.3. Please do not check in something
#   for 3.5.0 or higher because it will break LTS operating systems
#   and a number of developer boards used for testing. To test your
#   changes, please set up a Ubuntu 14.05 LTS system.

# Should we be setting things like this? We are not a C project
# so nothing should be done with the C compiler. But there is
# no reliable way to tell CMake we are C++.
# Cannot set this... Breaks Linux PowerPC with Clang:
# SET(CMAKE_C_COMPILER ${CMAKE_CXX_COMPILER})
# # error "The CMAKE_C_COMPILER is set to a C++ compiler"

if(NOT DEFINED cryptopp_DISPLAY_CMAKE_SUPPORT_WARNING)
  set(cryptopp_DISPLAY_CMAKE_SUPPORT_WARNING 1)
endif()
if(cryptopp_DISPLAY_CMAKE_SUPPORT_WARNING)
  message( STATUS
"*************************************************************************\n"
"The Crypto++ library does not officially support CMake. CMake support is a\n"
"community effort, and the library works with the folks using CMake to help\n"
"improve it. If you find an issue then please fix it or report it at\n"
"https://github.com/noloader/cryptopp-cmake.\n"
"-- *************************************************************************"
)
endif()

# Print useful information
message( STATUS "CMake version ${CMAKE_VERSION}" )
message( STATUS "System ${CMAKE_SYSTEM_NAME}" )
message( STATUS "Processor ${CMAKE_SYSTEM_PROCESSOR}" )

if (${CMAKE_VERSION} VERSION_LESS "3.0.0")
  project(cryptopp)
  set(cryptopp_VERSION_MAJOR 8)
  set(cryptopp_VERSION_MINOR 6)
  set(cryptopp_VERSION_PATCH 0)
else ()
  cmake_policy(SET CMP0048 NEW)
  project(cryptopp VERSION 8.6.0)
  if (NOT ${CMAKE_VERSION} VERSION_LESS "3.1.0")
    cmake_policy(SET CMP0054 NEW)
  endif ()
endif ()

# Need to set SRC_DIR manually after removing the Python library code.
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})

# Make RelWithDebInfo the default (it does e.g. add '-O2 -g -DNDEBUG' for GNU)
#   If not in multi-configuration environments, no explicit build type or CXX
#   flags are set by the user and if we are the root CMakeLists.txt file.
if (NOT CMAKE_CONFIGURATION_TYPES AND
    NOT CMAKE_NO_BUILD_TYPE AND
    NOT CMAKE_BUILD_TYPE AND
    NOT CMAKE_CXX_FLAGS AND
    CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif ()

include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

# We now carry around test programs. test_cxx.cpp is the default C++ one.
# Also see https://github.com/weidai11/cryptopp/issues/741.
set(TEST_PROG_DIR ${SRC_DIR}/TestPrograms)
set(TEST_CXX_FILE ${TEST_PROG_DIR}/test_cxx.cpp)

# https://github.com/noloader/cryptopp-cmake/issues/56
# https://stackoverflow.com/a/40152725
if (APPLE)
  set(USE_INTERMEDIATE_OBJECTS_TARGET OFF)
endif()

#============================================================================
# Settable options
#============================================================================

option(BUILD_STATIC "Build static library" ON)
option(BUILD_SHARED "Build shared library" OFF)
option(BUILD_TESTING "Build library tests" ON)
option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
option(USE_INTERMEDIATE_OBJECTS_TARGET "Use a common intermediate objects target for the static and shared library targets" ON)

if (${CMAKE_VERSION} VERSION_GREATER "3.1")
  option(USE_OPENMP "Enable OpenMP to parallelize some of the algorithms. Note that this isn't always faster, see https://www.cryptopp.com/wiki/OpenMP" OFF)
endif()


# These are IA-32 options.
option(DISABLE_ASM "Disable ASM" OFF)
option(DISABLE_SSSE3 "Disable SSSE3" OFF)
option(DISABLE_SSE4 "Disable SSE4" OFF)
option(DISABLE_AESNI "Disable AES-NI" OFF)
option(DISABLE_CLMUL "Disable CLMUL" OFF)
option(DISABLE_SHA "Disable SHA" OFF)
option(DISABLE_AVX "Disable AVX" OFF)
option(DISABLE_AVX2 "Disable AVX2" OFF)

# These are ARM A-32 options
option(DISABLE_ARM_NEON "Disable NEON" OFF)

# These are Aarch64 options
option(DISABLE_ARM_AES "Disable ASIMD" OFF)
option(DISABLE_ARM_AES "Disable AES" OFF)
option(DISABLE_ARM_PMULL "Disable PMULL" OFF)
option(DISABLE_ARM_SHA "Disable SHA" OFF)

# These are PowerPC options
option(DISABLE_ALTIVEC "Disable Altivec" OFF)
option(DISABLE_POWER7 "Disable POWER7" OFF)
option(DISABLE_POWER8 "Disable POWER8" OFF)
option(DISABLE_POWER9 "Disable POWER9" OFF)

set(CRYPTOPP_DATA_DIR "" CACHE PATH "Crypto++ test data directory")

#============================================================================
# Compiler options
#============================================================================

set(CRYPTOPP_COMPILE_DEFINITIONS)
set(CRYPTOPP_COMPILE_OPTIONS)

# Stop hiding the damn output...
# set(CMAKE_VERBOSE_MAKEFILE ON)

# Stop CMake complaining...
if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(MACOSX_RPATH FALSE)
endif()

# Always 1 ahead in Master. Also see http://groups.google.com/forum/#!topic/cryptopp-users/SFhqLDTQPG4
set(LIB_VER ${cryptopp_VERSION_MAJOR}${cryptopp_VERSION_MINOR}${cryptopp_VERSION_PATCH})

if (CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
  list(APPEND CRYPTOPP_COMPILE_OPTIONS -wd68 -wd186 -wd279 -wd327 -wd161 -wd3180)
endif ()

# Also see http://github.com/weidai11/cryptopp/issues/395
if (DISABLE_ASM)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ASM)
endif ()
if (DISABLE_SSSE3)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SSSE3)
endif ()
if (DISABLE_SSE4)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SSSE4)
endif ()
if (DISABLE_CLMUL)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_CLMUL)
endif ()
if (DISABLE_AESNI)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AESNI)
endif ()
if (DISABLE_RDRAND)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_RDRAND)
endif ()
if (DISABLE_RDSEED)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_RDSEED)
endif ()
if (DISABLE_AVX)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AVX)
endif ()
if (DISABLE_AVX2)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AVX2)
endif ()
if (DISABLE_SHA)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SHA)
endif ()
if (DISABLE_ARM_NEON)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_NEON)
endif ()
if (DISABLE_ARM_ASIMD)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_ASIMD)
endif ()
if (DISABLE_ARM_AES)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_AES)
endif ()
if (DISABLE_ARM_PMULL)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_PMULL)
endif ()
if (DISABLE_ARM_SHA)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_SHA)
endif ()
if (DISABLE_ALTIVEC)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ALTIVEC)
endif ()
if (DISABLE_POWER7)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_POWER7)
endif ()
if (DISABLE_POWER8)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_POWER8)
endif ()
if (DISABLE_POWER9)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_POWER9)
endif ()
if (NOT CRYPTOPP_DATA_DIR STREQUAL "")
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS "CRYPTOPP_DATA_DIR=${CRYPTOPP_DATA_DIR}")
endif ()

###############################################################################

# Try to find a Posix compatible grep and sed. Solaris, Digital Unix,
#   Tru64, HP-UX and a few others need tweaking

if (EXISTS /usr/xpg4/bin/grep)
  set(GREP_CMD /usr/xpg4/bin/grep)
elseif (EXISTS /usr/gnu/bin/grep)
  set(GREP_CMD /usr/gnu/bin/grep)
elseif (EXISTS /usr/linux/bin/grep)
  set(GREP_CMD /usr/linux/bin/grep)
else ()
  set(GREP_CMD grep)
endif ()

if (EXISTS /usr/xpg4/bin/sed)
  set(SED_CMD /usr/xpg4/bin/sed)
elseif (EXISTS /usr/gnu/bin/sed)
  set(SED_CMD /usr/gnu/bin/sed)
elseif (EXISTS /usr/linux/bin/sed)
  set(SED_CMD /usr/linux/bin/sed)
else ()
  set(SED_CMD sed)
endif ()

###############################################################################

function(CheckCompileOption opt var)

  if (MSVC)

    # TODO: improve this...
    CHECK_CXX_COMPILER_FLAG(${opt} ${var})

  elseif (CMAKE_CXX_COMPILER_ID MATCHES "SunPro")

    message(STATUS "Performing Test ${var}")
    execute_process(
      COMMAND sh -c "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_FLAGS} ${opt} -c ${TEST_CXX_FILE} 2>&1"
      COMMAND ${GREP_CMD} -i -c -E "illegal value ignored"
      RESULT_VARIABLE COMMAND_RESULT
      OUTPUT_VARIABLE COMMAND_OUTPUT
      OUTPUT_STRIP_TRAILING_WHITESPACE)

    # No dereference below. Thanks for the warning, CMake (not!).
    if (COMMAND_RESULT AND NOT COMMAND_OUTPUT)
      set(${var} 1 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  # Must use CMAKE_CXX_COMPILER here due to XLC 13.1 and LLVM front-end.
  elseif (CMAKE_CXX_COMPILER MATCHES "xlC")

    message(STATUS "Performing Test ${var}")
    execute_process(
      COMMAND sh -c "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_FLAGS} ${opt} -c ${TEST_CXX_FILE} 2>&1"
      COMMAND ${GREP_CMD} -i -c -E "Unrecognized value"
      RESULT_VARIABLE COMMAND_RESULT
      OUTPUT_VARIABLE COMMAND_OUTPUT
      OUTPUT_STRIP_TRAILING_WHITESPACE)

    # No dereference below. Thanks for the warning, CMake (not!).
    if (COMMAND_RESULT AND NOT COMMAND_OUTPUT)
      set(${var} 1 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  else ()

    CHECK_CXX_COMPILER_FLAG(${opt} ${var})

  endif ()

endfunction(CheckCompileOption)

function(CheckCompileLinkOption opt var prog)

  if (MSVC)

    # TODO: improve this...
    CHECK_CXX_COMPILER_FLAG(${opt} ${var})

  elseif (APPLE)

    message(STATUS "Performing Test ${var}")
    try_compile(COMMAND_SUCCESS ${CMAKE_BINARY_DIR} ${prog} COMPILE_DEFINITIONS ${opt})
    if (COMMAND_SUCCESS)
      set(${var} 1 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  else ()

    message(STATUS "Performing Test ${var}")
    try_compile(COMMAND_SUCCESS ${CMAKE_BINARY_DIR} ${prog} COMPILE_DEFINITIONS ${opt})
    if (COMMAND_SUCCESS)
        set(${var} 1 PARENT_SCOPE)
        message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  endif ()

endfunction(CheckCompileLinkOption)

function(AddCompileOption opt)

    if ("${COMMAND_OUTPUT}" NOT STREQUAL "")
      list(APPEND CRYPTOPP_COMPILE_OPTIONS "${opt}")
    endif ()

endfunction(AddCompileOption)

###############################################################################

function(DumpMachine output pattern)

  if (MSVC)

    # CMake does not provide a generic shell/terminal mechanism
    #  and Microsoft environments don't know what 'sh' is.
    set(${output} 0 PARENT_SCOPE)

  else ()
    execute_process(
      COMMAND sh -c "${CMAKE_CXX_COMPILER} -dumpmachine 2>&1"
      COMMAND ${GREP_CMD} -i -c -E "${pattern}"
      OUTPUT_VARIABLE ${output}
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    set(${output} "${${output}}" PARENT_SCOPE)
  endif()

endfunction(DumpMachine)

# Thanks to Anonimal for MinGW; see http://github.com/weidai11/cryptopp/issues/466
DumpMachine(CRYPTOPP_AMD64 "(x86_64|AMD64|amd64)")
DumpMachine(CRYPTOPP_I386 "^i.86$")
DumpMachine(CRYPTOPP_MINGW32 "^mingw32")
DumpMachine(CRYPTOPP_MINGW64 "(w64-mingw32|mingw64)")
DumpMachine(CRYPTOPP_ARMV8 "(armv8|arm64|aarch32|aarch64)")
DumpMachine(CRYPTOPP_ARM32 "(arm|armhf|arm7l|eabihf)")
DumpMachine(CRYPTOPP_PPC32 "^(powerpc|ppc)")
DumpMachine(CRYPTOPP_PPC64 "^ppc64")

# Cleanup 32/64 bit
if (CRYPTOPP_AMD64)
  set (CRYPTOPP_I386 0)
endif ()

=== debian/tests/control ===
Test-Command: cd obj-`dpkg-architecture -q DEB_BUILD_GNU_TYPE` && SECUREFS_BINARY=`pwd`/securefs python3 ../test/simple_test.py
Depends: fuse,
         libcrypto++-dev,
         libfuse-dev,
         libjsoncpp-dev,
         libutf8proc-dev,
         python3
Restrictions: build-needed, isolation-machine, allow-stderr

Test-Command: cd obj-`dpkg-architecture -q DEB_BUILD_GNU_TYPE` && ./securefs_test
Depends: fuse, libcrypto++-dev, libfuse-dev, libjsoncpp-dev, libutf8proc-dev
Restrictions: build-needed, allow-stderr

## securefs 0.13.1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 11)

project(securefs)
enable_testing()
cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0069 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)

include(CheckIPOSupported)
check_ipo_supported(RESULT IPO_SUPPORTED OUTPUT error)

if(IPO_SUPPORTED)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE ON)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELWITHDEBINFO ON)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_MINSIZEREL ON)
endif()
set(CMAKE_FIND_FRAMEWORK NEVER)

execute_process(COMMAND bash -c "uname -m" OUTPUT_VARIABLE architecture)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake-modules/")
include(GetGitRevisionDescription)
git_describe(GIT_VERSION --tags)
configure_file(${CMAKE_SOURCE_DIR}/sources/git-version.cpp.in
               ${CMAKE_BINARY_DIR}/git-version.cpp)

file(COPY ${CMAKE_SOURCE_DIR}/external/cmake-cryptopp/CMakeLists.txt
     DESTINATION ${CMAKE_SOURCE_DIR}/external/cryptopp)

if(UNIX)
    find_path(FUSE_INCLUDE_DIR fuse.h PATHS /usr/local/include)
    find_library(FUSE_LIBRARIES fuse PATHS /usr/local/lib)
    include_directories(${FUSE_INCLUDE_DIR})
    link_libraries(${FUSE_LIBRARIES})
    add_compile_options(-Wall -Wextra -Wno-unknown-pragmas)

    if(APPLE)
        link_libraries(-Wl,-dead_strip)
    else()
        add_compile_options(-pthread)
        link_libraries(-pthread)
    endif()
    link_libraries(${CMAKE_DL_LIBS})
else()
    add_definitions(-DNOMINMAX=1)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS=1)
    add_definitions(-D__STDC__=1)
    if(NOT WINFSP_PREFIX)
        message("WINFSP_PREFIX not set, fallback to default value")
        set(WINFSP_PREFIX "C:/Program Files (x86)/WinFsp")
    endif()
    if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
        set(ARCH x64)
    else()
        set(ARCH x86)
    endif()
    set(FUSE_INCLUDE_DIR ${WINFSP_PREFIX}/inc/fuse)
    include_directories(${WINFSP_PREFIX}/inc)
    include_directories(${FUSE_INCLUDE_DIR})
    link_libraries(${WINFSP_PREFIX}/lib/winfsp-${ARCH}.lib)
    link_libraries(delayimp.lib)
    if(MSVC)
        link_libraries(-DELAYLOAD:winfsp-${ARCH}.dll)
        add_compile_options(/utf-8)
    elseif(MINGW)
        link_libraries(-delayload=winfsp-${ARCH}.dll)
    endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wthread-safety)
    if(MINGW)
        add_compile_options(-fansi-escape-codes -fcolor-diagnostics)
    endif()
endif()

add_definitions(-D_REENTRANT -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=28
                -DUTF8PROC_EXPORTS=1)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

include_directories(sources)
set(EXTERNAL_DIR external)
include_directories(${EXTERNAL_DIR})

set(CRYPTOPP_DIR ${EXTERNAL_DIR}/cryptopp)
add_subdirectory(${CRYPTOPP_DIR})
link_libraries(cryptopp-static)

add_subdirectory(${EXTERNAL_DIR}/argon2)
include_directories(${EXTERNAL_DIR}/argon2/include)
link_libraries(argon2_static)

file(
    GLOB
    SOURCES
    sources/*.cpp
    sources/*.h
    ${EXTERNAL_DIR}/*.h
    ${EXTERNAL_DIR}/*.hpp
    ${EXTERNAL_DIR}/*.cpp
    ${CMAKE_BINARY_DIR}/git-version.cpp
    ${EXTERNAL_DIR}/utf8proc/utf8proc.h
    ${EXTERNAL_DIR}/utf8proc/utf8proc.c)
file(GLOB TEST_SOURCES test/*.h test/*.cpp)
add_library(securefs-static STATIC ${SOURCES})
link_libraries(securefs-static)

if(MSVC)
    add_executable(securefs main.cpp securefs.manifest)
else()
    add_executable(securefs main.cpp)
endif()

add_executable(securefs_test ${TEST_SOURCES})

add_test(NAME sec_test COMMAND securefs_test)
find_package(Python3 COMPONENTS Interpreter)
if(Python3_FOUND)
    add_test(
        NAME simple_test
        COMMAND ${CMAKE_COMMAND} -E env SECUREFS_BINARY=$<TARGET_FILE:securefs>
                ${Python3_EXECUTABLE} ${PROJECT_SOURCE_DIR}/test/simple_test.py)
endif()

install(TARGETS securefs DESTINATION bin)

if(MINGW)
    target_link_libraries(securefs PRIVATE -municode)
endif()

=== debian/changelog ===
securefs (0.13.1+ds-1ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:58:30 +1100

securefs (0.13.1+ds-1ubuntu3) noble; urgency=high

  * No change rebuild against libfuse2t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:54:29 +0100

securefs (0.13.1+ds-1ubuntu2) noble; urgency=medium

  * Rebuild against latest utf8proc

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 30 Oct 2023 07:30:11 -0400

securefs (0.13.1+ds-1ubuntu1) mantic; urgency=medium

  * Set SECUREFS_BINARY in debian/test/control (LP: #2018707).

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Mon, 08 May 2023 07:14:48 +0200

securefs (0.13.1+ds-1) unstable; urgency=medium

  * New upstream version 0.13.1+ds

 -- Yanhao <yanhaocs@gmail.com>  Fri, 27 Jan 2023 10:31:37 +0800

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,8 @@
                libjsoncpp-dev,
                libtclap-dev,
                libutf8proc-dev,
-               libutfcpp-dev
+               libutfcpp-dev,
+               libargon2-dev
 Rules-Requires-Root: no
 Standards-Version: 4.6.0
 Homepage: https://github.com/netheril96/securefs

=== debian/watch ===
version=4
opts="dversionmangle=auto, repacksuffix=+ds, \
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%securefs-$1.tar.gz%" \
 https://github.com/netheril96/securefs/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
